#
# mipssim/sbd.mk: MIPSsim generic "board" configuration
#

SBDDIRS		=../mipssim
SBDFLAGS  	=-DMIPSSIM -D__SIM

# Enable MIPS16 support in kit code; disable h/w timer profiling
KITFLAGS	=-D__maybe_mips16 -D_SDE_EXT_PROFIL

# These three will change for different simulated architectures
CPU	  	=4kc
ISA		=-mips32
ENDIAN	  	=-EB
FPU		=no

SBDSRC		=sbdreset.sx sbdser.sx sbdmisc.sx
SBDOBJ		=sbdser.o sbdmisc.o r4kclock.o
SBDLOW		=sbdreset.o sbdser.o sbdmisc.o 

MONITOR		=mdimon
BAREMON		=mdimon

# Prefer to copy ROM code to RAM for better performance.
# But disable for now, since it makes debugging more confusing.
#SBDLAYOUT	=romcopy

# Convert ROM image to relocated ELF format for download by GDB
ROMDLFMT	=relf

# Don't define DLBASE or DLFMT, to prevent us from building RAM loadable 
# executables for MIPSsim - we should only be generating ROM images.

#DLBASE_C	=80100000
#DLBASE_U	=a0100000
#DLFMT		=s3
